package project;

import java.util.ArrayList;

import exceptions.CategoryInvalidException;
import exceptions.DescriptionInvalidException;
import exceptions.ImageInvalidException;
import exceptions.TitleInvalidException;

public class Item {

	static int idCounter;
	public static ArrayList<Item> items = new ArrayList<Item>();
	private ArrayList<ItemPicture> images = new ArrayList<ItemPicture>();
	private int id, userOwner;
	private String title, description;
	Category cat;

	public Item() {

		this.title = "";
		this.description = "";

		id = idCounter++;
		items.add(this);

	}

	public Item(String title, String description, ArrayList<ItemPicture> itemPictures, Category c) {

		this.cat = c;
		this.title = title;
		this.description = description;
		this.images = itemPictures;
		id = idCounter++;
		items.add(this);

	}

	public static Item getInstance() {

		Item i = new Item();

		return i;

	}

	public static boolean delete(Integer itemId) {

		Item i = Item.getItem(itemId);

		if (i != null && items.contains(i)) {

			items.remove(items.indexOf(i));
			return true;

		}

		return false;

	}

	public boolean addPicture(ArrayList<ItemPicture> picList) throws ImageInvalidException {

		if (picList.size() < 1 || picList.size() > 10) {
			throw new ImageInvalidException();
		} else {
			this.setImages(picList);
			return true;
		}

	}

	public ArrayList<Auction> getAuctionHistory() {

		return null;

	}

	public static Item getItem(int item) {

		for (Item i : items) {

			if (item == i.getId()) {

				return i;
			}

		}

		return null;

	}

	public ItemPicture getImage(int img) {

		for (ItemPicture i : images) {

			if (img == i.getId()) {

				return i;
			}

		}

		return null;

	}

	public boolean modify(String title, String description, String category)
			throws CategoryInvalidException, DescriptionInvalidException, TitleInvalidException {

		if (!title.matches("^[a-zA-Z]+$") || title.length() > 30 || title.length() < 1) {

			throw new TitleInvalidException();

		} else if (description.matches("^\\W+$|\\d+") || description.length() > 500 || description.length() < 1) {

			throw new DescriptionInvalidException();

		} else {

			Category c = Category.getCategory(category);

			if (c == null) {

				throw new CategoryInvalidException();

			} else {
				this.setDescription(description);
				this.setCategory(Category.getCategory(category));
				this.setTitle(title);
				return true;
			}
		}
	}

	public void setDescription(String d) {
		this.description = d;

	}

	public void setId(int i) {

		this.id = i;
	}

	public int getId() {
		return id;
	}

	public void setOwner(int newOwner) {

		this.userOwner = newOwner;

	}

	public String getTitle() {

		return this.title;

	}

	public Category getCategory() {

		return this.cat;
	}

	public void setTitle(String title2) {

		this.title = title2;

	}

	public void setCategory(Category category) {

		this.cat = category;

	}

	public void setImages(ArrayList<ItemPicture> list) {

		this.images = list;

	}

	public ArrayList<ItemPicture> getImages() {
		return images;
	}

}
