package fitNesseFixture;

import java.text.ParseException;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

import exceptions.BidBelowZeroException;
import project.Auction;
import project.AuctionManager;
import project.User;

public class AuctionManagerFixture {

	private AuctionManager managerInstance;
	private User user;
	private int value;

	public AuctionManagerFixture(int usr) {

		user = new User(usr);

	}

	public String placeBid() {

		Auction a = new Auction();

		LocalDateTime l = LocalDateTime.of(2020, 12, 25, 12, 0, 0);

		a.setEnd(AuctionManager.parseDate(l.format(DateTimeFormatter.ofPattern("dd/MM/yyyy HH:mm:ss"))));

		managerInstance = AuctionManager.getInstance();
		managerInstance.setAuction(a);

		try {

			if (managerInstance.placeBid(user, value)) {

				return "Bid placed!";

			}

		} catch (BidBelowZeroException e) {

			return e.getMessage();

		} catch (ParseException e) {

			return e.getMessage();
		}

		return null;

	}

	public void setValue(int value) {

		this.value = value;

	}

	public void setAb(AuctionManager ab) {

		this.managerInstance = ab;

	}

}
